#!/bin/sh
#
# $Header: /alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.15 2008/06/28 00:37:45 niro Exp $
#
# AutoSta_LX Installation Script
#
# Niels Rogalla <niro@magellan-linux.de>
#		<rogalla@augusta-bochum.de>
#
#
# Install Navigation Gui
#

#images: (get ${CDIMAGENAME})
source /mnt/cdrom/system/images.conf

#Includes
source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null
### bugfix ###############################
cdromdev="$(echo ${cdromdev} | sed 's/ //')"
########################################

### System/Config Version
VERSION="0.3.1"
TITLE="alxinstall-ng - ${VERSION}"

CDPATH="/mnt/cdrom"
INSTALLPATH="/mnt/magellan"

### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1
CURRENTLINE=0
#TOTALLINES=11072 # -> now in images.conf


#################################################
#		  DIALOG BOXEN			#
#################################################

die()
{
	ERROR=$1
	RETVAL=$?
	dialog_install_failure
	exit 1
}

dialog_warning()
{
	dialog \
	--backtitle "${TITLE}" \
	--colors \
	--defaultno \
	--yesno "\Z1 !!! Achtung !!! \Zn\n\n\
	Diese Festplatte wird unwiederruflich geloescht werden.\n\n\
		Soll ich wirklich fortfahren ?" 10 70
	RES=$?
	if [[ ${RES} -eq 1 ]]
	then
		clear
		echo "Der Vorgang wurde abgebrochen."
		exit 1
	fi
}

dialog_setup_hdd_info()
{
	local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"

	dialog \
	--colors \
	--title "[ Festplatten Partitionierung ]" \
	--backtitle "${TITLE}" \
	--ok-label "Weiter" \
	--msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\
		[ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\
		[ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\
		[ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\
		Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
}

dialog_setup_hdd_info_flash()
{
	local SHDD="$(echo $HDD | sed 's/\/dev\///')"

	dialog \
	--colors \
	--title "[ Festplatten Partitionierung ]" \
	--backtitle "${TITLE}" \
	--ok-label "Weiter" \
	--msgbox "\nBitte legen Sie 1 Partition an.\n\n\
		[ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\
		Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81
}

dialog_setup_system_menu()
{
	local i

	i=$(dialog \
	--backtitle "${TITLE}" \
	--title "[ Festplatten Partitionierung ]" \
	--cancel-label "Abbrechen" \
	--ok-label "Weiter" \
	--stdout \
	--menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \
	"1" "Normale IDE-Disk" \
	"2" "Flash-Speicher")
	RES=$?
	[[ ${RES} -eq 1 ]] && return 1
	if [[ ${RES} -eq 0 ]]
	then
		case "${i}" in
        		"1") run_install_normal ;;
			"2") run_install_flash ;;
		esac
	fi
}

dialog_setup_hdd_found_manuell()
{
	local i

	[[ ! -z ${installdevs} ]] && installdevs=""

	echo "dialog \\"  > /tmp/hddtmp.sh
	echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh
	echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh
	echo "--stdout \\" >> /tmp/hddtmp.sh
	echo "--colors \\" >> /tmp/hddtmp.sh
	echo "--msgbox \"Gefundene Hardware:\n\n \\" >> /tmp/hddtmp.sh
	echo "	Festplatten:\n \\" >> /tmp/hddtmp.sh

	if [[ ! -z ${scsidisks} ]]
	then
		for i in ${scsidisks}
		do
			if [[ ${i} != ${cdromdev} ]]
			then
				echo "		\\Z7SCSI: \\Z3${i}\\Zn\n \\" >> /tmp/hddtmp.sh
				installdevs="${installdevs} ${i}"
			fi
		done
	fi

	if [[ ! -z ${idedisks} ]]
	then
		for i in ${idedisks}
		do
			if [[ ${i} != ${cdromdev} ]]
			then
				echo "		\\Z7IDE:  \\Z3${i}\\Zn\n \\" >> /tmp/hddtmp.sh
				installdevs="${installdevs} ${i}"
			fi
		done
	fi

	if [[ ! -z ${cdromdev} ]]
	then
		echo "	\n \\" >> /tmp/hddtmp.sh
		echo "	\\Z7andere Laufwerke:\n \\" >> /tmp/hddtmp.sh
		echo "		CDROM: \\Z3${cdromdev}\\Zn\n \\" >> /tmp/hddtmp.sh
	fi
	echo "	\" 13 70" >> /tmp/hddtmp.sh
	chmod a+x /tmp/hddtmp.sh
	/tmp/hddtmp.sh
}

dialog_setup_hdd_partitions_manuell()
{
	local i

	if [[ -z ${installdevs} ]]
	then
		dialog \
		--backtitle "${TITLE}" \
		--ok-label "Beenden" \
		--msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70
		exit 1
	else

		echo "dialog \\" > /tmp/hddtmp.sh
		echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh
		echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh
		echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh
		echo "--stdout \\" >> /tmp/hddtmp.sh
		echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh

		for i in ${installdevs}
		do
			echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
		done
		echo -e "\n" >> /tmp/hddtmp.sh

		chmod a+x /tmp/hddtmp.sh
		HDD="$(/tmp/hddtmp.sh)"
		RES=$?
		[[ ${RES} -eq 1 ]] && return 1
		if [[ ${RES} -eq 0 ]]
		then
			dialog_setup_hdd_info
			setup_hdd_partitions_manuell
		fi
	fi
}

dialog_setup_hdd_partitions_manuell_flash()
{
	local i

	if [[ -z ${installdevs} ]]
	then
		dialog \
		--backtitle "${TITLE}" \
		--ok-label "Beenden" \
		--msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70
		exit 1
	else

		echo "dialog \\" > /tmp/hddtmp.sh
		echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh
		echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh
		echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh
		echo "--stdout \\" >> /tmp/hddtmp.sh
		echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh

		for i in ${installdevs}
		do
			echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh
		done
		echo -e "\n" >> /tmp/hddtmp.sh

		chmod a+x /tmp/hddtmp.sh
		HDD="$(/tmp/hddtmp.sh)"
		RES=$?
		[[ ${RES} -eq 1 ]] && return 1
		if [[ ${RES} -eq 0 ]]
		then
			dialog_setup_hdd_info_flash
			setup_hdd_partitions_manuell_flash
		fi
	fi
}

dialog_setup_hdd_format()
{
	dialog \
	--backtitle "${TITLE}" \
	--infobox "Erstelle Datei-Systeme ..." 3 70
}

dialog_install_settings()
{
	dialog \
	--backtitle "${TITLE}" \
	--infobox "Speichere System-Einstellungen ..." 3 70
}

dialog_install_system_image()
{
	dialog \
	--backtitle "${TITLE}" \
	--gauge "Kopiere System-Image ..." 6 80
}

dialog_install_meter()
{
	while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
	do
		CURRENTLINE=$(grep -c . /tmp/install.log)
		PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
		echo ${PERCENT}
		sleep 1
	done
	rm -f /tmp/install.log
	return 0
}


dialog_install_bootsector()
{
	dialog \
	--backtitle "${TITLE}" \
	--infobox "Schreibe den Bootsektor ..." 3 70
}

dialog_install_successful()
{
	dialog \
	--backtitle "${TITLE}" \
	--colors \
	--msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81
}

dialog_install_failure()
{
	dialog \
	--backtitle "${TITLE}" \
	--colors \
	--msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\
		Fehler bei ${ERROR}, RetVal: ${RETVAL} \
	" 10 81
}

dialog_main()
{
	METHOD=0

	while [[ ${METHOD} -le 2 ]]
	do
		METHOD=$(dialog \
		--backtitle "${TITLE}" \
		--no-cancel \
		--ok-label "Weiter" \
		--stdout \
		--menu "Konfiguration" 14 70 5 \
		"1" "AutoSta_LX installieren" \
		"2" "Uebersicht gefundener Laufwerke" \
		"3" "Beenden und neustarten" \
		"4" "Beenden und eine Shell starten")
		RES=$?
		[[ ${RES} -eq 1 ]] && exit 1
		if [[ ${RES} -eq 0 ]]
		then
			case ${METHOD} in
        			"1") dialog_setup_system_menu ;;
				"2") dialog_setup_hdd_found_manuell ;;
				"3") install_do_reboot ;;
				"4") /bin/bash --login -i ;;
			esac
		fi
	done
}

#################################################
#		Install Komandos		#
#################################################
setup_hdd_partitions_manuell()
{
	BOOTHDD="${HDD}1"
	SWAPHDD="${HDD}2"
	ROOTHDD="${HDD}3"

	## hdds partitionieren manuell
	cfdisk ${HDD} || die
}

setup_hdd_partitions_manuell_flash()
{
	ROOTHDD="${HDD}1"

	## hdds partitionieren manuell
	cfdisk ${HDD} || die
}

setup_hdd_format()
{
	mkswap ${SWAPHDD} || die
	mke2fs -j -q ${BOOTHDD} || die
	mke2fs -j -q ${ROOTHDD} || die
}

setup_hdd_format_flash()
{
	mke2fs -j -q ${ROOTHDD} || die
}

install_mount_rootfs()
{
	swapon ${SWAPHDD} || die
	mount ${ROOTHDD} ${INSTALLPATH} || die
	install -d ${INSTALLPATH}/boot || die
	mount ${BOOTHDD} ${INSTALLPATH}/boot || die
	cd ${INSTALLPATH} || die
}

install_mount_rootfs_flash()
{
	mount ${ROOTHDD} ${INSTALLPATH} || die
	install -d ${INSTALLPATH}/boot || die
	cd ${INSTALLPATH} || die
}

install_system_image()
{
	tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}
}

install_bootsector_chroot()
{
	### grubconf schreiben
	source ${INSTALLPATH}/boot/kernelversion

	#for alx only
	if [ -e ${INSTALLPATH}/etc/alx_version ]
	then
		OLD_ALXVER="${ALXVER}"
		source ${INSTALLPATH}/etc/alx_version
		KRNVER="ALX-${ALXVER}"
		ALXVER="${OLD_ALXVER}"
	fi

	[[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
	[[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"

	echo "default 0" > ${INSTALLPATH}/boot/grub/grub.conf || die
	echo "timeout 0" >> ${INSTALLPATH}/boot/grub/grub.conf ||die

	echo -e "\ntitle=${KRNVER}" >> ${INSTALLPATH}/boot/grub/grub.conf || die
	echo "root (hd0,0)" >> ${INSTALLPATH}/boot/grub/grub.conf || die
	
	echo "kernel /boot/vmlinuz root=${ROOTHDD} quiet" >> ${INSTALLPATH}/boot/grub/grub.conf || die
	echo "initrd /boot/initrd" >> ${INSTALLPATH}/boot/grub/grub.conf || die
	
	# bootsector schreiben chrooted schreiben (lfs/magellan)
	cat > ${INSTALLPATH}/root/.bashrc << CHROOTEOF
/usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
root (hd0,0)
setup (hd0)
quit
EOF
exit 0
CHROOTEOF

	## enters chroot
	mount -t proc proc ${INSTALLPATH}/proc
	mount -t sysfs sysfs ${INSTALLPATH}/sys
	mount -o bind /dev ${INSTALLPATH}/dev
	chroot ${INSTALLPATH} /bin/bash --rcfile /root/.bashrc -i
	umount ${INSTALLPATH}/proc
	umount ${INSTALLPATH}/sys
	umount ${INSTALLPATH}/dev
	rm ${INSTALLPATH}/root/.bashrc
}

install_mkinitrd_chroot()
{
	cat > ${INSTALLPATH}/root/.bashrc << CHROOTEOF
echo "MODULES=\"ext3 amd74xx piix sis5513 via82cxxx\"" > /etc/conf.d/mkinitrd
mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
exit 0
CHROOTEOF

	## enters chroot
	mount -t proc proc ${INSTALLPATH}/proc
	mount -t sysfs sysfs ${INSTALLPATH}/sys
	mount -o bind /dev ${INSTALLPATH}/dev
	chroot ${INSTALLPATH} /bin/bash --rcfile /root/.bashrc -i
	umount ${INSTALLPATH}/proc
	umount ${INSTALLPATH}/sys
	umount ${INSTALLPATH}/dev
	rm ${INSTALLPATH}/root/.bashrc
}

install_system_settings()
{
	# schreibe fstab
	echo -e "${BOOTHDD}\t/boot\text3\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die
	echo -e "${ROOTHDD}\t/\text3\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die
	echo -e "${SWAPHDD}\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die
	echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die
	echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die

	# install network config skeleton
	install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die
}

install_system_settings_flash()
{
	# schreibe fstab
	echo -e "${ROOTHDD}\t/\text3\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die
	echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die
	echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die
}

install_umount_rootfs()
{
	cd /
	umount ${INSTALLPATH}/boot || die
	umount ${INSTALLPATH} || die
	swapoff ${SWAPHDD} || die
}

install_umount_rootfs_flash()
{
	cd /
	umount ${INSTALLPATH} || die
}

install_do_reboot()
{
	reboot
}

#################################################
#	     Install Ablauf Scripte		#
#################################################

run_install_normal()
{
	dialog_setup_hdd_found_manuell

	dialog_setup_hdd_partitions_manuell
	dialog_setup_hdd_format
	setup_hdd_format > /dev/null
	install_mount_rootfs
	(install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image

	dialog_install_bootsector
	install_bootsector_chroot

	dialog_install_settings
	sleep 1
	install_system_settings
	install_mkinitrd_chroot
	install_umount_rootfs
	dialog_install_successful
}

run_install_flash()
{
	dialog_setup_hdd_found_manuell

	dialog_setup_hdd_partitions_manuell_flash
	dialog_setup_hdd_format
	setup_hdd_format_flash > /dev/null
	install_mount_rootfs_flash
	(install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image

	dialog_install_bootsector
	install_bootsector_chroot

	dialog_install_settings
	sleep 1
	install_system_settings_flash
	install_mkinitrd_chroot
	install_umount_rootfs_flash
	dialog_install_successful
}

dialog_main

exit 0
